//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "VictorMediaPlayer.h"
#include "UnitVmpFullScreen.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormVmpFullScreen *FormVmpFullScreen;
bool _bFormVmpFullScreenCreated = false;
//---------------------------------------------------------------------------
__fastcall TFormVmpFullScreen::TFormVmpFullScreen(TComponent* Owner)
    : TForm(Owner)
{
  _vmp = NULL;
  _hWndOldVideo = NULL;
  _bShowPanel = false;

  PanelFunctions->Visible = false;
  PanelFunctions->DoubleBuffered = true;
  LabelPosition->Font->Color = clWhite;

  _bFormVmpFullScreenCreated = true;
}
//---------------------------------------------------------------------------
__fastcall TFormVmpFullScreen::~TFormVmpFullScreen()
{
  _bFormVmpFullScreenCreated = false;
}
//---------------------------------------------------------------------------
void TFormVmpFullScreen::SetVmp(TVictorMediaPlayer *p)
{
  _vmp = p;
  _hWndOldVideo = _vmp ? _vmp->hWndVideo : NULL;
  if(_vmp)_vmp->hWndVideo = PanelVideo->Handle; // ȫģʽŵ PanelVideo 
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::FormClose(TObject *Sender, TCloseAction &Action)
{
  if(_vmp)_vmp->hWndVideo = _hWndOldVideo; // ָģʽŵĿؼ
  Action = caFree;                         // ͷȫģʽĴԴ
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PanelVideoMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
  _bShowPanel = Y>PanelVideo->Height-PanelFunctions->Height; // ƶĻ׶ˣʾĻ׶˵Ĺ
  if(_bShowPanel)
   {
     if(!PanelFunctions->Visible)
      {
        PanelFunctions->Left = 0;
        PanelFunctions->Top = PanelVideo->Height;
        PanelFunctions->Width = PanelVideo->Width;
        PanelFunctions->Visible = true;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::TimerPlayerTimer(TObject *Sender)
{
  if(_bShowPanel)
   {
     int tp0 = PanelVideo->Height - PanelFunctions->Height;
     int tp = PanelFunctions->Top;
     if(tp>tp0)
      {
        tp-=8;
        if(tp<tp0)tp=tp0;
        PanelFunctions->Top=tp;
      }
   }
  else
   {
     if(PanelFunctions->Visible)
      {
        if(PanelFunctions->Top<PanelVideo->Height)
          PanelFunctions->Top = PanelFunctions->Top + 8;
        else
          PanelFunctions->Visible = false;
      }
   }
  if(PanelFunctions->Visible && _vmp)
   {
     double d = _vmp->Duration;
     if(d>0)
      {
        double p = _vmp->Position;
        PaintBoxProgress->Invalidate();
        LabelPosition->Caption = FormatDateTime(L"hh:nn:ss",p/86400.0) + L"/"+ FormatDateTime(L"hh:nn:ss", d/86400.0);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PaintBoxProgressPaint(TObject *Sender)
{
  TCanvas *cvs = PaintBoxProgress->Canvas;
  int w = PaintBoxProgress->Width;
  int h = PaintBoxProgress->Height;
  int t = 0;

  if(_vmp)
   {
     double d = _vmp->Duration;
     if(d>0)
      {
        double p = _vmp->Position;
        t = w*p/d + 0.5;
      }
   }
  cvs->Pen->Style = psSolid;
  for(int y=0; y<h; y++)
   {
     cvs->Pen->Color = TColor(RGB(0,128-96*y/h,255-191*y/h));
     cvs->MoveTo(0,y); cvs->LineTo(t,y);
     cvs->Pen->Color = TColor(RGB(96+96*y/h,96+96*y/h,96+96*y/h));
     cvs->MoveTo(t,y); cvs->LineTo(w,y);
   }
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PaintBoxProgressMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
  _bSetPos = true;
  SetVmpPos(X,PaintBoxProgress->Width);
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PaintBoxProgressMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
  if(_bSetPos)
    SetVmpPos(X,PaintBoxProgress->Width);
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PaintBoxProgressMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
  _bSetPos = false;
}
//---------------------------------------------------------------------------
void TFormVmpFullScreen::SetVmpPos(int x, int w)
{
  if(_vmp)
   {
     if(_vmp->PlayState==vmpsRunning && w>0)
      {
        double d = _vmp->Duration;
        if(d>0)
         {
           _vmp->Position = x*d/(double)w;
         }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PaintBoxFunctionsPaint(TObject *Sender)
{
  TCanvas *cvs = PaintBoxFunctions->Canvas;
  int w = PaintBoxFunctions->Width;
  int h = PaintBoxFunctions->Height;
  cvs->Pen->Style = psSolid;
  for(int y=0; y<h; y++)
   {
     cvs->Pen->Color = TColor(RGB(128-96*y/h,128-96*y/h,128-96*y/h));
     cvs->MoveTo(0,y); cvs->LineTo(w,y);
   }
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PaintBoxClosePaint(TObject *Sender)
{
  TCanvas *cvs = PaintBoxClose->Canvas;
  int w = PaintBoxClose->Width;
  int h = PaintBoxClose->Height;
  for(int y=0; y<h; y++)
   {
     for(int x=0; x<w; x++)
      {
        int v = PaintBoxClose->Tag ? 192-96*(x+y)/(w+h) : 128-96*(x+y)/(w+h);
        cvs->Pixels[x][y] = TColor(RGB(v,v,v));
      }
   }
  cvs->Pen->Style = psSolid;
  cvs->Pen->Color = PaintBoxClose->Tag ? clRed : clWhite;
  cvs->MoveTo(3,3); cvs->LineTo(w-2,h-2);
  cvs->MoveTo(3,h-3); cvs->LineTo(w-2,2);
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PaintBoxCloseMouseEnter(TObject *Sender)
{
  PaintBoxClose->Tag = 1;
  PaintBoxClose->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PaintBoxCloseMouseLeave(TObject *Sender)
{
  PaintBoxClose->Tag = 0;
  PaintBoxClose->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PaintBoxCloseClick(TObject *Sender)
{
  Close(); // رհť˳ȫģʽ
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::FormKeyPress(TObject *Sender, wchar_t &Key)
{
  if(Key==27 || Key==13) // Esc  س
    Close();             // ˳ȫģʽ
}
//---------------------------------------------------------------------------
void __fastcall TFormVmpFullScreen::PanelVideoDblClick(TObject *Sender)
{
  Close(); // ˫Ƶ˳ȫģʽ
}
//---------------------------------------------------------------------------
